<?php
/*	=====================================================
	anchor, Version 1.05.000
	=====================================================

$module_directory     = 'anchor';
$module_name          = 'Anchor';
$module_function      = 'page';
$module_version       = '1.05.000';
$module_platform      = '2.x';
$module_author        = 'Wolfgang Studer';
$module_license       = 'GNU General Public License';
$module_license_terms = '-';
$module_description   = 'Set an anchor where you need one';
$module_guid          = 'b1d60471-0648-44e9-8e90-509076a13aa0';
$module_home          = 'www.wolfgangstuder.ch | www.lepton-cms.com';
$lepador_link         = 'http://www.lepton-cms.com/lepador/modules/anchor.php';
$forum_link           = 'http://forum.lepton-cms.org/viewtopic.php?f=66&t=3060';

=====================================================

INTRO
==================================

Ein Modul für das LEPTON CMS.

Mit diesem Modul kann ein Anker an einer beliebigen Stelle zwischen 2 Abschnitten
erstellt werden und mittels einem Library Aufruf im Frontend eine Liste aller definierter
Anker dieser Seite abgerufen werden.
Diese Liste kann dann in ein Menu eingebaut werden.

Die view.php Ausgabe ist nur ein Kommentar, da der LEPTON CMS Interne Anker als
Sprungziel verwendet wird.
Somit kann gezielt definiert werden, welche Abschnitte als Sprungziel im Menu erscheinen.

Dieses Modul unterstützt das Modul "lib_logger" und kann damit verschiedene
Fehler, Aktivitäten und SQLs in einer Datenbank Tabelle speichern und im Modul
"logger" anzeigen.
Die Module "lib_logger" und "logger" sind optional und für den
Betrieb dieses Modules nicht zwingend.

Dieses Modul unterstützt das Modul "lib_dependency" zur Sicherstellung von
Abhängigkeiten während einer De-Installation.
Das Modul "lib_dependency" ist optional und für den Betrieb dieses Modules nicht
zwingend.
Das Modul kann auch nachträglich installiert werden, vorhandene Abhängigkeiten
werden semi-automatisch eingetragen (register_dependency.php).
Siehe auch die README.de.txt Datei von "lib_dependency" für weitere Informationen.

PRE-REQUIREMENTS
==================================
>=       2.2 : LEPTON_VERSION
>=       5.6 : PHP_VERSION
>=  1.04.000 : WB_ADDONS[ 'lib_setuphelper' ]
>=  1.24.0.0 : WB_ADDONS[ 'lib_twig' ]
>=  0.03.001 : WB_ADDONS[ 'lib_dependency' ] (optional)
>=  0.05.002 : WB_ADDONS[ 'lib_logger' ] (optional)

INSTALLATION
==================================

1. Lade die letzte Version von
	http://www.lepton-cms.com/lepador/modules/anchor.php
2. Melde dich im Lepton CMS Backend an
3. Gehe zu Erweiterungen -> Module
4. Im Block "Modul installieren", wähle die im Schritt 1 heruntergeladene
	anchor ZIP Datei, dann klicke auf den "Installieren" Button.


DE-INSTALLATION
==================================

1. Melde dich im Lepton CMS Backend an
2. Gehe zu Erweiterungen -> Module
3. Im Block "Modul deinstallieren", wähle das Modul "anchor",
	dann klicke auf den "Deinstallieren" Button.

BENUTZUNG VON anchor
==================================

A) Benutzung im Backend

Erstelle einen neuen Abschnitt auf einer Seite deiner Wahl mit "Art" = "anchor".

In diesem Abschnitt sind:
- Zwei Formular-Felder, in denen zumindest im Feld "Name" einen auf dieser Seite
	eindeutigen Namen erfasst werden muss. Ausserdem kann ein optionaler Text erfasst
	werden, welcher im Menu angezeigt wird anstelle des Namens.
- Eine Möglichkeit, diesen Abschnitt mit einem Klick zu aktivieren/deaktivieren.
- Ein Notitz Feld für interne Informationen zu diesem Abschnitt
- Ein "Speichern" Button
- Ein "Abbrechen" Button


B) Benutzung im Frontend Template

Im Frontend wird für einen Abschnitt dieses Moduls nur ein Kommentar angezeigt.
LEPTON CMS erstellt jedoch für jeden Abschnitt einen Anker davor.

Beim Aufruf der Library Funktion "anchor_get_anchors( $page_id )" wird eine Liste zurückgegeben,
welche als Schlüssel die Anker ID (z.B. Lep_1) und als Wert den Menu Text (sofern vorhanden)
bzw den Anker Namen zurückgibt.
Mittels dieser Liste kann dann ein Sprungziel Menu erzeugt werden, jedoch muss das Menu
individuell im Template erzeugt werden.

> include( LEPTON_PATH . DIRECTORY_SEPARATOR . 'modules' . DIRECTORY_SEPARATOR . 'anchor' . DIRECTORY_SEPARATOR . 'library.php' );
> $anchors = anchor_get_anchors( $page_id );
> if ( count( $anchors ) > 0 ):
> 	// anchors has been found
>	...
> else:
>	// no anchors found
>	...
> endif;



BENUTZUNG VON lib_dependency
==================================

Beachte bitte das diese Funktion nur verfügbar ist, wenn das Modul "lib_dependency"
installiert ist!

Während der normalen Benutzung des Moduls "anchor" wird man nichts vom
Modul "lib_dependency" bemerken.

Nur in den folgenden Situationen macht sich "lib_dependency" bemerkbar:
- wenn jemand versucht, eine als abhängig registriertes Modul von "anchor"
zu De-Installieren, erscheint eine Fehlermeldung und die De-Installation des abhängigen
Moduls wird abgebrochen ("anchor" ist "Eltern-Modul").
- wenn jemand versucht, "anchor" zu De-Installieren und "anchor"
ist eine registrierte Abhängigkeit eines anderen Moduls, erscheint eine Fehlermeldung
und die De-Installation von "anchor" wird abgebrochen
("anchor" ist "Kind-Modul").

EIGENE ERWEITERUNGEN
===========================

Dieses Modul wurde so entwickelt, das es durch den System-Administrator an verschiedenen
Punkten erweitert werden kann, ohne im Modul selbst Aenderungen vorzunehmen und dadurch
die Aenderungen bei einem allfälligen Update zu verlieren.
Hier nachfolgend die Punkte und Dateien:

Benutze Variablen:
- {LEPTON_PATH}   = der LEPTON CMS Installations Pfad
- {DEFAULT_THEME} = das verwendete Backend Theme
- {TEMPLATE}      = das verwendete Frontend Template
- {COMPONENT}     = der Komponenten Name, z.B. "modify_optionizer"
- {LANGUAGE}      = der momentan verwendete Sprachcode, in Grossbuchstaben

- {BACKEND_PATH}  = {LEPTON_PATH}/templates/{DEFAULT_THEME}/backend/anchor
- {FRONTEND_PATH} = {LEPTON_PATH}/templates/{TEMPLATE}/frontend/anchor


Für das Backend:
- {BACKEND_PATH}/backend.css
	>> hier kann das verwendete Standard Style überschrieben werden.
		Wenn diese Datei vorhanden ist wird die Standard Datei NICHT verwendet!

- {BACKEND_PATH}/languages/{LANGUAGE}.php
	>> hier kann der verwendete Standard Text überschrieben werden.
		Diese Datei wird ausgeführt, nachdem die Standard Datei ausgeführt wurde.

- {BACKEND_PATH}/lib/lib.backend.config.{COMPONENT}.php
	>> In dieser Datei können Standard Konfigurations Werte überschrieben werden.
		Diese Datei wird ausgeführt, nachdem die Standard Datei ausgeführt wurde.

- {BACKEND_PATH}/lib/lib.data.{COMPONENT}.php
	>> diese Datei wird ausgeführt, nachdem das SQL ausgeführt wurde. Benutze diese Datei
		wenn Daten manipuliert werden sollen, bevor diese an die TWIG Engine übergeben
		werden.
		Diese Datei wird ausgeführt, nachdem die Standard Datei ausgeführt wurde.

- {BACKEND_PATH}/lib/lib.twig.{COMPONENT}.php
	>> Benutze diese Datei, wenn zusätzliche Variablen im TWIG Template verwendet werden
		sollen.
		Diese Datei wird ausgeführt, nachdem die Standard Datei ausgeführt wurde.

- {BACKEND_PATH}/templates/backend/{COMPONENT}.lte
	>> mit dieser Datei kann das Standard Template ersetzt werden.
		Wenn diese Datei vorhanden ist wird die Standard Datei NICHT verwendet!
	Wichtig: Es kann auch ein Template  mit einem anderen Namen verwendet werden.
	Dazu muss in: {BACKEND_PATH}/lib/lib.twig.{COMPONENT}.php
	folgendes definiert werden:
		// define twig template
		$twigTemplate =  '<<dein Template Name>>';

Für das Frontend:
- {FRONTEND_PATH}/frontend.css
	>> hier kann das verwendete Standard Style überschrieben werden
		Wenn diese Datei vorhanden ist wird die Standard Datei NICHT verwendet!

- {FRONTEND_PATH}/languages/{LANGUAGE}.php
	>> hier kann der verwendete Standard Text überschrieben werden.
		Diese Datei wird geladen, nachdem die Standard Datei geladen wurde.

- {FRONTEND_PATH}/lib/lib.backend.config.{COMPONENT}.php
	>> In dieser Datei können Standard Konfigurations Werte überschrieben werden.
		Diese Datei wird geladen, nachdem die Standard Datei geladen wurde.

- {FRONTEND_PATH}/lib/lib.data.{COMPONENT}.php
	>> diese Datei wird ausgeführt, nachdem das SQL ausgeführt wurde. Benutze diese Datei
		wenn Daten manipuliert werden sollen, bevor diese an die TWIG Engine übergeben
		werden.
		Diese Datei wird geladen, nachdem die Standard Datei geladen wurde.

- {FRONTEND_PATH}/lib/lib.twig.{COMPONENT}.php
	>> Benutze diese Datei, wenn zusätzliche Variablen im TWIG Template verwendet werden
		sollen.
		Diese Datei wird geladen, nachdem die Standard Datei geladen wurde.

- {FRONTEND_PATH}/templates/frontend/{COMPONENT}.lte
	>> mit dieser Datei kann das Standard Template ersetzt werden.
		Wenn diese Datei vorhanden ist wird die Standard Datei NICHT verwendet!
	Wichtig: Es kann auch ein Template  mit einem anderen Namen verwendet werden.
	Dazu muss in: {FRONTEND_PATH}/lib/lib.twig.{COMPONENT}.php
	folgendes definiert werden:
		// define twig template
		$twigTemplate =  '<<dein Template Name>>';



WEITERE DOKUMENTATION
===========================

Weitere Informationen zu diesem Modul findet sich im LEPTON CMS Forum
http://forum.lepton-cms.org/index.php

!! Beachtet bitte das das Forum nur in englischer Sprache geführt wird !!


Enjoy!
*/
?>
