<?php
/*	=====================================================
	anchor, Version 1.05.000
	=====================================================

$module_directory     = 'anchor';
$module_name          = 'Anchor';
$module_function      = 'page';
$module_version       = '1.05.000';
$module_platform      = '2.x';
$module_author        = 'Wolfgang Studer';
$module_license       = 'GNU General Public License';
$module_license_terms = '-';
$module_description   = 'Set an anchor where you need one';
$module_guid          = 'b1d60471-0648-44e9-8e90-509076a13aa0';
$module_home          = 'www.wolfgangstuder.ch | www.lepton-cms.com';
$lepador_link         = 'http://www.lepton-cms.com/lepador/modules/anchor.php';
$forum_link           = 'http://forum.lepton-cms.org/viewtopic.php?f=66&t=3060';

=====================================================

INTRO
==================================

A module for the LEPTON CMS software.

With this module, an anchor can be created between 2 sections at any place between all
sections of a page. By using a library function call, a list of all such specified
anchors can be created and used then within a menu.

The view.php output is just a comment, because the LEPTON CMS internal anchor created
before each section is used.
With this module you can explicitly define, which of these sections should be used as
menu targets.

This module supports the module "lib_logger". With "lib_logger",
errors, activities and SQLs can be saved in a database table and shown via the module
"logger".
The modules "lib_logger" and "logger" are optional and not
mandatory for the usage of this module.

This module supports the module "lib_dependency" to secure the availability of
dependencies during de-installations.
The module "lib_dependency" is optional and not mandatory for the usage of this
module.
The module can be installed later on, defined dependencies will be semi-automatically
registered (register_dependency.php).
See README.en.txt of "lib_dependency" for more details about.

PRE-REQUIREMENTS
==================================
>=       2.2 : LEPTON_VERSION
>=       5.6 : PHP_VERSION
>=  1.04.000 : WB_ADDONS[ 'lib_setuphelper' ]
>=  1.24.0.0 : WB_ADDONS[ 'lib_twig' ]
>=  0.03.001 : WB_ADDONS[ 'lib_dependency' ] (optional)
>=  0.05.002 : WB_ADDONS[ 'lib_logger' ] (optional)

INSTALLATION
==================================

1. Download the latest version from
	http://www.lepton-cms.com/lepador/modules/anchor.php
2. Log into your Lepton CMS backend
3. Go to Addons -> Modules
4. In the "Install Module" section, enter the path to the anchor zip file
	that you downloaded in step 1, and choose the "Install" button.


DE-INSTALLATION
==================================

1. Log into your Lepton CMS backend
2. Go to Addons -> Modules
3. In the "Uninstall Module" section, select the module "anchor",
	and choose the "Uninstall" button.

USING anchor
==================================

A) Usage in backend

Create first a new section on any page using "Art" = "anchor".

Within this module section there is:
- Two Formula-Fields, where at least the field "name" has be to set with a unique name on
	this page. Additionally you can also add a menu text, which is shown in the menu
	instead of the name.
- a possibility to set the module active/inactive
- a notes field for internal notes on this section.
- a "Save" button
- a "Cancel" button


B) Usage in frontend template

This module simply generates a comment in the frontend view, however LEPTON CMS creates
for each section a specific anchor before.

By calling the library function "anchor_get_anchors( $page_id )" a list is returned, having
the specified anchor ID (e.g Lep_1) as key and the menu text (if available, else the name)
as value.
With this list a menu can be generated, however the menu generation you have to do on your
own.

> include( LEPTON_PATH . DIRECTORY_SEPARATOR . 'modules' . DIRECTORY_SEPARATOR . 'anchor' . DIRECTORY_SEPARATOR . 'library.php' );
> $anchors = anchor_get_anchors( $page_id );
> if ( count( $anchors ) > 0 ):
> 	// anchors has been found
>	...
> else:
>	// no anchors found
>	...
> endif;



USAGE of lib_dependency
==================================

Note that this functionality is available only if "lib_dependency" is installed!

During normal usage of the module "anchor", you will not notice anything
about "lib_dependency".

Only in the following cases you will see the availability of "lib_dependency":
- when someone tries to de-install any of the modules registered as childs of
"anchor", an error appears and de-installation of the child module is
forbidden ("anchor" is parent).
- when someone tries to de-install "anchor" and "anchor" is
registered as child of another module, an error appears and de-installation of
this "anchor" module is forbidden ("anchor" is child).

OWN ENHANCEMENTS
===========================

This module is build in a way that it can be enhanced by system administrator at various
points without any risk that enhancements gets lost during next updates.
Hereafter the points & files:

Variables used:
- {LEPTON_PATH}   = the LEPTON CMS installation path
- {DEFAULT_THEME} = the backend theme used
- {TEMPLATE}      = the frontend template used
- {COMPONENT}     = the component name, e.g. "modify_optionizer"
- {LANGUAGE}      = the currently used language code, uppercase

- {BACKEND_PATH}  = {LEPTON_PATH}/templates/{DEFAULT_THEME}/backend/anchor
- {FRONTEND_PATH} = {LEPTON_PATH}/templates/{TEMPLATE}/frontend/anchor


For backend:
- {BACKEND_PATH}/backend.css
	>> use this file to overwrite the default layout styles.
		If this file exists, the default file will not be used!

- {BACKEND_PATH}/languages/{LANGUAGE}.php
	>> use this file to overwrite the default provided text.
		This file is loaded after the standard file have been processed.

- {BACKEND_PATH}/lib/lib.backend.config.{COMPONENT}.php
	>> you can overwrite here default config settings.
		This file is loaded after the standard file have been processed.

- {BACKEND_PATH}/lib/lib.data.{COMPONENT}.php
	>> data have been retrieved. use this script when you want to modify the data before
		they are passed to the TWIG template engine
		This file is loaded after the standard file have been processed.

- {BACKEND_PATH}/lib/lib.twig.{COMPONENT}.php
	>> use this for passing additional values towards the TWIG template.
		This file is loaded after the standard file have been processed.

- {BACKEND_PATH}/templates/backend/{COMPONENT}.lte
	>> use this file to use your own template
		If this file exists, the default file will not be used!
	Note that you can use also a template with a different name by specifying it as:
		// define twig template
		$twigTemplate =  '<<your template name>>';
	in: {BACKEND_PATH}/lib/lib.twig.{COMPONENT}.php

For frontend:
- {FRONTEND_PATH}/frontend.css
	>> use this fiel to overwrite the default layout styles
		If this file exists, the default file will not be used!

- {FRONTEND_PATH}/languages/{LANGUAGE}.php
	>> use this file to overwrite the default provided text.
		This file is loaded after the standard file have been processed.

- {FRONTEND_PATH}/lib/lib.frontend.config.{COMPONENT}.php
	>> you can overwrite here default config settings.
		This file is loaded after the standard file have been processed.

- {FRONTEND_PATH}/lib/lib.data.{COMPONENT}.php
	>> data have been retrieved. use this script when you want to modify the data before
		they are passed to the TWIG template engine
		This file is loaded after the standard file have been processed.

- {FRONTEND_PATH}/lib/lib.twig.{COMPONENT}.php
	>> use this for passing additional values towards the TWIG template.
		This file is loaded after the standard file have been processed.

- {FRONTEND_PATH}/templates/frontend/{COMPONENT}.lte
	>> use this file to use your own template
		If this file exists, the default file will not be used!
	Note that you can use also a template with a different name by specifying it as:
		// define twig template
		$twigTemplate =  '<<your template name>>';
	in: {FRONTEND_PATH}/lib/lib.twig.{COMPONENT}.php



FURTHER DOCUMENTATION
===========================

Further documentation about this module can be found in the LEPTON CMS forum at
http://forum.lepton-cms.org/index.php


Enjoy!
*/
?>
