<?php

/**  // € // to identify files as UTF8
 * Set an anchor where you need one
 *
 * @module          anchor
 * @author          Wolfgang Studer
 * @copyright       2016 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.05.000 | 2016-12-17
 * @lepador_link    http://www.lepton-cms.com/lepador/modules/anchor.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3060
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


/*
 * Ajax call: confirm a link
 */

// check input
	$inputs = array();
	$inputs[ 'action' ]			= array( 'filter' => FILTER_SANITIZE_STRING, 'required' => 1 );
	$inputs[ 'row_key' ]		= array( 'filter' => FILTER_SANITIZE_STRING, 'required' => 1 );
	$inputs[ 'row_id' ]			= array( 'filter' => FILTER_SANITIZE_NUMBER_INT, 'required' => 1 );

	$inputs[ 'type' ]			= array( 'filter' => FILTER_SANITIZE_STRING );
	$inputs[ 'prefix' ]			= array( 'filter' => FILTER_SANITIZE_STRING );
	$inputs[ 'sectionprefix' ]	= array( 'filter' => FILTER_SANITIZE_STRING );
	$inputs[ 'addroot' ]		= array( 'filter' => FILTER_SANITIZE_NUMBER_INT );
	$inputs[ 'page_id' ]		= array( 'filter' => FILTER_SANITIZE_STRING );
	$inputs[ 'root' ]			= array( 'filter' => FILTER_SANITIZE_STRING );
	$inputs[ 'folder' ]			= array( 'filter' => FILTER_SANITIZE_STRING );
	$inputs[ 'replace' ]		= array( 'filter' => FILTER_SANITIZE_STRING );

	$inputs[ 'leptoken' ]		= array( 'filter' => FILTER_SANITIZE_STRING );

// set $module as current module
	$anchor_module = 'anchor';

// set processing initials
	unset( $twigTemplate );
	$anchor_component = basename( __FILE__, '.php' );
	$anchor_modulePath = dirname( __FILE__ ) . DIRECTORY_SEPARATOR;
	$includes = array();

// Include admin class script
	include( LEPTON_PATH . '/framework/class.admin.php');
	$admin = new admin( 'Dialog', 'start', false, false );

// include the basic files at start
	// setup module initials
	$includes[]	= array( 'LOADER'=> 'require', 'FILE' => $anchor_modulePath . 'register_initial.php' );
	include( $anchor_modulePath . 'load_includes.php' );

	// include language registration
	$includes[]	= $anchor_modulePath . 'register_language.php';
	// include backend config files
	$includes[]	= $anchor_modulePath . 'lib/lib.config.php';
	$includes[]	= $anchor_modulePath . 'lib/lib.backend.config.php';
	$includes[]	= $anchor_templatePath . 'lib/lib.backend.config.php';
	$includes[]	= $anchor_modulePath . 'lib/lib.backend.config.' . $anchor_component . '.php';
	$includes[]	= $anchor_templatePath . 'lib/lib.backend.config.' . $anchor_component . '.php';
	// include basic functions
	$includes[]	= $anchor_templatePath . 'lib/lib.backend.functions.' . $anchor_component . '.php';
	$includes[]	= $anchor_templatePath . 'lib/lib.backend.functions.php';
	$includes[]	= $anchor_modulePath . 'lib/lib.backend.functions.' . $anchor_component . '.php';
	$includes[]	= $anchor_modulePath . 'lib/lib.backend.functions.php';
	// do include
	include( $anchor_modulePath . 'load_includes.php' );

	// initialize data variable
	$data = array();

// assign default type used in language files
	$type = $anchor_component;

// initialize messages shown in dialog
	$messages = array();

// initialize data variable
	$data = array();

// init ajax output
	$anchor_response = '';

// do input validation
	if ( $_SERVER["REQUEST_METHOD"] == 'POST' ):
		$error = anchor_input_filter( 'POST', $_POST, $inputs );
	else:
		$error = anchor_input_filter( 'GET', $_GET, $inputs );
	endif;
	if ( $error != 0 ):
		$status = FALSE;
		$messages['ERROR'][] = $MOD_ANCHOR['ERROR']['INPUT'] . ' [ ' . $error . ' ]' . '<br />' . $inputs[$error][ 'error' ];
		unset( $inputs );

	else:
		// initialize data variable
		$data = array();
		$data['PARENT'] = array();
		$data['CHILD']  = array();

		// save input into local vars
		$action			= $inputs[ 'action' ][ 'value' ];
		$row_key		= $inputs[ 'row_key' ][ 'value' ];
		$row_id			= $inputs[ 'row_id' ][ 'value' ];
		$leptoken		= $inputs[ 'leptoken' ][ 'value' ];

		$selectParams = array();
		if (( array_key_exists( 'type', $inputs )						== TRUE )
		and ( array_key_exists( 'value', $inputs[ 'type' ] )			== TRUE )
		and ( strlen( $inputs[ 'type' ][ 'value' ] )					>  0    )):
			$selectParams[ 'type' ]			= $inputs[ 'type' ][ 'value' ];
		endif;
		if (( array_key_exists( 'prefix', $inputs )						== TRUE )
		and ( array_key_exists( 'value', $inputs[ 'prefix' ] )			== TRUE )
		and ( strlen( $inputs[ 'prefix' ][ 'value' ] )					>  0    )):
			$selectParams[ 'prefix' ]		= $inputs[ 'prefix' ][ 'value' ];
		endif;
		if (( array_key_exists( 'sectionprefix', $inputs )				== TRUE )
		and ( array_key_exists( 'value', $inputs[ 'sectionprefix' ] )	== TRUE )
		and ( strlen( $inputs[ 'sectionprefix' ][ 'value' ] )			>  0    )):
			$selectParams[ 'sectionprefix' ]= $inputs[ 'sectionprefix' ][ 'value' ];
		endif;
		if (( array_key_exists( 'addroot', $inputs )					== TRUE )
		and ( array_key_exists( 'value', $inputs[ 'addroot' ] )			== TRUE )
		and ( strlen( $inputs[ 'addroot' ][ 'value' ] )					>  0    )):
			$selectParams[ 'addroot' ]		= $inputs[ 'addroot' ][ 'value' ];
		endif;
		if (( array_key_exists( 'page_id', $inputs )					== TRUE )
		and ( array_key_exists( 'value', $inputs[ 'page_id' ] )			== TRUE )
		and ( strlen( $inputs[ 'page_id' ][ 'value' ] )					>  0    )):
			$selectParams[ 'page_id' ]		= $inputs[ 'page_id' ][ 'value' ];
		endif;
		if (( array_key_exists( 'root', $inputs )						== TRUE )
		and ( array_key_exists( 'value', $inputs[ 'root' ] )			== TRUE )
		and ( strlen( $inputs[ 'root' ][ 'value' ] )					>  0    )):
			$selectParams[ 'root' ]			= $inputs[ 'root' ][ 'value' ];
		endif;
		if (( array_key_exists( 'folder', $inputs )						== TRUE )
		and ( array_key_exists( 'value', $inputs[ 'folder' ] )			== TRUE )
		and ( strlen( $inputs[ 'folder' ][ 'value' ] )					>  0    )):
			$selectParams[ 'folder' ]		= $inputs[ 'folder' ][ 'value' ];
		endif;
		if (( array_key_exists( 'replace', $inputs )					== TRUE )
		and ( array_key_exists( 'value', $inputs[ 'replace' ] )			== TRUE )
		and ( strlen( $inputs[ 'replace' ][ 'value' ] )					>  0    )):
			$selectParams[ 'replace' ]		= $inputs[ 'replace' ][ 'value' ];
		endif;

		unset( $inputs );

		// initialize status
		$status = TRUE;

		// prepare SQL
			// no data access here

		// data manipulation
		// include data manipulation files
		$includes[]	= $anchor_modulePath . 'lib/lib.data.php';
		$includes[]	= $anchor_templatePath . 'lib/lib.data.php';
		$includes[]	= $anchor_modulePath . 'lib/lib.data.' . $anchor_component . '.php';
		$includes[]	= $anchor_templatePath . 'lib/lib.data.' . $anchor_component . '.php';
		include( $anchor_modulePath . 'load_includes.php' );
	endif;

// start output buffer
	$buffer = TRUE;

// twig processing
		// include template engine files
		global $parser, $loader;
		$includes[]	= $anchor_modulePath . 'lib/lib.twig.formvalues.php' ;				// initial setting of formvalues
		$includes[]	= $anchor_modulePath . 'lib/lib.twig.php' ;						// module specific formvalues
		$includes[]	= $anchor_templatePath . 'lib/lib.twig.php' ;						// module specific formvalues
		$includes[]	= $anchor_modulePath . 'lib/lib.twig.' . $anchor_component . '.php' ;		// component specific formvalues
		$includes[]	= $anchor_templatePath . 'lib/lib.twig.' . $anchor_component . '.php' ;	// local enhancements of formvalues
		$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $anchor_modulePath . 'register_parser.php' );
		include( $anchor_modulePath . 'load_includes.php' );

		// check if twig template is defined
		if ( isset( $twigTemplate ) == FALSE ):
			// define default twig template
			$twigTemplate =  $anchor_component . '.lte';
		endif;

		// process page
		$twig_util->resolve_path( $twigTemplate );

		// buffer output
		if ( isset( $buffer ) == TRUE ):
			// start output buffer
			ob_start();
		endif;

		echo $parser->render(
			$twig_modul_namespace . $twigTemplate,
			$form_values
		);

// get output buffer content
	$anchor_response = ob_get_contents();

// clear & end output buffer
	ob_end_clean();

	// output
	if ( $status == TRUE ):
		$status = 1;
	else:
		$status = -1;
	endif;
	echo json_encode( array( 'status' => $status, 'data' => $data, 'ResponseText' => $anchor_response ) );
	return true;
?>
