<?php

/**  // € // to identify files as UTF8
 * Set an anchor where you need one
 *
 * @module          anchor
 * @author          Wolfgang Studer
 * @copyright       2016 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.05.000 | 2016-12-17
 * @lepador_link    http://www.lepton-cms.com/lepador/modules/anchor.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3060
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// loop over all includes for current part
	while( count( $includes ) > 0 ):

		// get first array item and remove it from array
		$include = array_shift( $includes );

		// when value is an array ...
		if ( is_array( $include ) == TRUE ):
			$loadType = mb_convert_case( $include[ 'LOADER' ], MB_CASE_LOWER, 'UTF-8' );
			$loadFile = $include[ 'FILE' ];
		else:
			$loadType = 'include';
			$loadFile = $include;
		endif;

		// check if file exists
		if ( file_exists( $loadFile ) == TRUE ):
			// include file
			switch ( $loadType ):
			case 'css':
				// check if backend.css file needs to be included into the <body></body>
				if ( method_exists( $admin, 'register_backend_modfiles') == FALSE ):
					echo '<style type="text/css">' . PHP_EOL;
					include( $loadFile );
					echo PHP_EOL . '</style>' . PHP_EOL;
				endif;
				break;

			case 'require':
				require( $loadFile );
				break;

			case 'require_once':
				require_once( $loadFile );
				break;

			case 'include_once':
				include_once( $loadFile );
				break;

			default:
				include( $loadFile );

			endswitch;

		else:
			// show error
			switch ( $loadType ):
			case 'require':
			case 'require_once':
				trigger_error( 'Include path "{' . $loadFile . '}" for "{' . $loadType . '}" not exists', E_USER_WARNING);
				break;

			endswitch;

		endif;
	endwhile;

// initialize array after processing
	$includes = array();

?>
